unit USEFUL;
{ Miscelaneous useful routines }

interface

  uses
    inifiles,classes,wintypes,winprocs,sysutils,dialogs,outline,
    messages,shellapi,dbgrids,
    grids,printers,forms,dbtables,stdctrls,controls,db,graphics,
    DbiTypes, DbiProcs, DbiErrs;

  type
  TlbLoadOption =  //  LoadListBoxFromTable option ) How to set the
      (lbloFile,   //  Select current TABLE record ) LB selection
       lbloList,   //  Select current LIST record  )
       lbloNone);  //  Leave unselected

  TPrinterSettings =
      (psLandscape,psPortrait,
       psSimplex,PsDuplexShort,psDuplexLong,
       psUpper,psLower,psLargeCapacity,
       psPaperType1,psPaperType2,psPaperType3);




  // strings
  function chop(var Mainstring : string; const Chopper : string):string;
  function dequote(const S: string):string;
  function InDexOfString(S:String; A : Array of string):integer;
  function GetValue(const Slist:TStringList;key:string;var RHSide:string):boolean;
  procedure Rtrim(var S:String);
  procedure Ltrim(var S:String);
  function rightStr(const S:string; const L:longint) : String;
  function SubStr(const S:string; const ToBeRepl:string; const ReplBy:string):string;
  Function TrimString(const S:String):String;
  Function UnCapitialise(const S:String):string;
  Function StringToArray(const S,chopper:String;  var A : Array of string):integer;
  Function DropZeros(const S:String):string;
  Function PenceToSterling(const Pence:Integer):string;
  Function SubStrip(const S,ToStrip,ToSub:string):string;



  // printing
  Function CommandPrinter(const Settings : Array of TPrinterSettings):Integer;
  Function SelectNamedPrinter(Const Pname:string):boolean;
  procedure CanvasTextOutAngle(c: TCanvas; x,y: Integer; d: Word; s: string);
  procedure CanvasSetTextAngle(c: TCanvas; d: Word);
  Function CentralH(const Left,Right:integer;const S:string):integer;
  Function CentralV(const Top,Bottom:integer; S:string):integer;
  Function AlignBaseV(const VBaseLine:integer;S:string):integer;
  procedure pdecimal(const H,V:integer; DecimalString:string);
  Function TW(const S:string):integer;
  procedure IncV(var V:integer; const S:string);
  function pix(const mm:integer):integer;
  function PX:integer;
  function PY:integer;
  procedure pline(const H:integer; var V:integer; const S:string);
  procedure pout(const H,V:integer; S:string);
  procedure poutonline(const H,V:integer; S:string);
  Function pwrappingheight(const H1,H2:integer; const ToBeWrapped:string):integer;
  procedure pwrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
  procedure _pwrapline(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
  procedure setfont(const fName:string;fSize:integer);

  // message boxes
  function mbox(const hand:Thandle;const Blurb,Title:string; Flags:word):Integer;
  function ConfirmBox(const Blurb:string):boolean;
  procedure OKBox(const Blurb:string);
  procedure AlertBox(const Blurb:string);

  // misc utilities==============================================
  // misc file
  function ExtendedFileexists(var fname:string; trypath:string):boolean;
  procedure uFileCopy(const FromFile, ToFile: string);
  procedure MakeBackupFile(const filename:string);
  function ReadIniSection(var IniFileName : string; const SectName : string; var SList : TStringList) : boolean;
  procedure delfile(const filename:string);
  // misc system
  procedure Trap;
  procedure HourGlass(const puton:boolean);
  function ProgramNameAndDate:String;
  // misc
  function Maximum(const A: array of variant):variant;
  function Minimum(const A: array of variant):variant;
  function StrToFloatDef(const S:string;const F:Extended):Extended;
  function ValidVariant(const V:Variant):boolean;
  // misc visual
  function RectHeight( R:Trect) : longint;
  Function RectWidth( R:Trect) : longint;
  function Vscrollwidth:Longint;
  function MaxLineHeight(const C:Tcanvas):longint;
  procedure WrapIntoGridCell(Sender: TObject; C, R: Longint;
            Rect: TRect; State: TGridDrawState);
  Function MemoExtend(var aMemo:TMemo;MaxHeight:Integer):integer;
  Function CheckTidyFloat(EB:TEdit):boolean;
  Procedure FlagEbGoodFloat(EB: TEdit; LA:TLabel; AllowZero:Boolean);
  Function HowWideShouldThisDBGridBe(const G:TDBGrid):integer;


  // date routines
  Function ReadDate(Const DS:String; var DT:TDateTime):Boolean;
  Function IsAValidDate(const yr,mo,dy:Word):boolean;
  Function SQLDate(Const D:TdateTime):string;
  Function BegOfTime:TDateTime;
  Function EndOfTime:TDateTime;
  Function ExtractYear(const D:TDateTime):word;
  procedure DateKeyService(EB: TEdit; var Key: Char);
  Function NiceSmallDate(const D:TDateTime):string;
  Function ParseDate(const DS: String; var dy,mo,yr:word):boolean;
  Function NotAValidDate:TDatetime;

  // Outline
  Function nthChild(const OL:Toutline;const ParentIx,ChildNo:integer):Integer;
  procedure MakeNodeVisible(var OL:Toutline;IX:Integer);
  procedure SortOutline(var OL:Toutline;const ix:integer);

  // database
  function LoadQueryBySQL(var AQuery:Tquery; const S:string):integer;
  Function WhereOrAnd(const SQL,Condition:string):string;
  function SQLCount(var AQuery:Tquery; const S:string):integer;
  function SLData(const ADataSet:TDBDataset; Const AField:String; var SL:TStringList):Boolean;
  function IntData(const ADataSet:TDBDataset; Const AField:String):integer;
  function NullField(const ADataSet:TDBDataset; Const AField:String):boolean;
  function DateData(const ADataSet:TDBDataset; Const AField:String; var DateResult:TDatetime):Boolean;
  function StrData(const ADataSet:TDBDataset; Const AField:String):string;
  function SingleData(const ADataSet:TDBDataset; Const AField:String):Single;
  function TFData(const ADataSet:TDBDataset; Const AField:String):boolean;
  procedure UpdateStrData(var ATable:TTable; Const AField,NewData:string;const EraseOnly:Boolean);
  function OneOfData(const ADataSet:TDBDataset; Const AField,TheOptions:String):integer;
  procedure tDeActivate(aTable:TTable);
  procedure tActivate(aTable:TTable);
  function TryEdit(aTable:TTable):boolean;
  Function SQLCopyRecords(Destination:TTable; CopyMode: TBatchMode;
                        const SQL:String;SourceDatabase:TDatabase):integer;
  procedure FlushTableBuffer(ATable: TTable);



var
  mmtopixel :single;
  WrapIsADummy : boolean;
  cascade : boolean;           // stopping cascading calls

const
  crlf : string[2]  = chr(13)+chr(10);
  lbloading : integer = 0;
  lbnotloading : integer = 1;

  // Standard constants used anywhere
  scSelect : integer = 0;  // set the tags on forms with grids in to
  scEdit : integer = 1;    // decide if ENTER calls edit or selects
  scValid : integer = 0;   // Set the tags on edit fields
  scNotValid : integer = 1;
  // database true/falses
  dbTrue : string = 'Y';
  dbFalse : string = 'N';


implementation









procedure _pwrapline(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ private - wraps a single line without any formatting characters }
var
  Charswide,ColWidth,PixPerChar : integer;
  WS,S,C: String;
Begin
  with printer.canvas do begin
    // get some basic dimensional estimates
    S := 'nnnnnnnnnnn';       // get a rough guide to no of pixels per char
    pixperchar := textwidth(S) div length(S);
    ColWidth := (h2-h1)-1;                               // width
    Charswide := ColWidth div PixPerChar;                // est no characters in col
    if charswide < 2 then ColWidth := PixPerChar * 2;    // min col width of 2 characters
    WS := trim(ToBeWrapped);

    // get one line's worth at a time
    while WS<>'' do begin
      // chop a guess from the front of the text
      S := copy(WS,1,Charswide);
      if WS=S then WS:='' else WS:=copy(WS,CharsWide+1,9999);
      // could we add more to S?
      while WS <> '' do begin
        if textwidth(S)>=Colwidth then break;
        S := S + copy(WS,1,1);
        if length(WS)=1 then WS:='' else WS := copy(ws,2,9999);
      end;
      // should we take something away from the end of S because it is too long?
      while textwidth(S)>Colwidth do begin
        WS := copy(S,length(s),1)+WS;
        S := copy(s,1,length(s)-1);
      end;
      // at this point we know S will fit into the space allowed but
      // we may want to look for a more convenient
      // break point.
      if ws <> '' then begin
        while true do begin
          C := copy(S,length(s),1);
          if pos(C,' .!%,?/:;-)')<>0 then break; // something good to end the line on
          ws := C+ws;
          S := copy(s,1,length(s)-1);
          if S = '' then begin              // trap when no breaks in text...
            S := copy(WS,1,Charswide);       // so guess a chop
            if WS=S then WS:='' else WS:=copy(WS,CharsWide+1,9999);
            break;
          end;
        end;
      end;
      // Now we have S as the string to print
      s := trim(s);
      if (not WrapIsADummy) then pline(H1,V,S);            // print what we have got
    end;
  end;
end;




procedure AlertBox(const Blurb:string);
{ pause with message.   Vertical bars in blurb act as CRLFs}
begin
  beep;
  mbox(application.handle,Blurb,'Note',48);
end;




Function AlignBaseV(const VBaseLine:integer;S:string):integer;
{ return a vertical value so that the baseline of the text will print
  at the VBASELINE position}
begin
  result := Vbaseline - printer.canvas.textheight(S);
  // @@@ NB this is a crude method - one day we'll have to read the proper
  // font parameters
end;




Function BegOfTime:TDateTime;
{ return a date notionally representing the beginning of time}
begin
  result := encodedate(1950,1,1);
end;




procedure CanvasSetTextAngle(c: TCanvas; d: Word);
{-----------------------------------------------------------
  PURPOSE
    To change the current text output rotation angle. All
    subsequent output will be at the angle provided.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.
    d - The angle in tenths of degrees. For example 10 would
      be 1 degree. 450 would be 45 degrees. 1 would be
      1/10 of a degree. To reset the text back to normal,
      make d = 0.

  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}
var
  LogRec: TLOGFONT;     {* Storage area for font information *}

begin
  {* Get the current font information. We only want to modify the angle *}
  GetObject(c.Font.Handle,SizeOf(LogRec),Addr(LogRec));

  {* Modify the angle. "The angle, in tenths of a degrees, between the base
     line of a character and the x-axis." (Windows API Help file.)*}
  LogRec.lfEscapement := d;
  LogRec.lfOrientation := d;

  {* Delphi will handle the deallocation of the old font handle and *}
  c.Font.Handle := CreateFontIndirect(LogRec);
end; {* CanvasSetTextAngle *}

{**********************************************************}




procedure CanvasTextOutAngle(c: TCanvas; x,y: Integer; d: Word; s: string);
{-----------------------------------------------------------
  PURPOSE
    To output rotated text in the same font as the font on
    the supplied canvas. The font must also be a scaleable
    font.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.

    x,y - The x,y screen coordinates you would normally
      supply the TextOut procedure.
    d - The angle in tenths of degrees. For example 10 would
      be 1 degree. 450 would be 45 degrees. 1 would be
      1/10 of a degree.
    s - The text to be output to the canvas.
  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}
var
  LogRec: TLOGFONT;     {* Storage area for font information *}
  OldFontHandle,        {* The old font handle *}
  NewFontHandle: HFONT; {* Temporary font handle *}

begin
  {* Get the current font information. We only want to modify the angle *}
  GetObject(c.Font.Handle, SizeOf(LogRec), Addr(LogRec));

  {* Modify the angle. "The angle, in tenths of a degrees, between the base
     line of a character and the x-axis." (Windows API Help file.)*}
  LogRec.lfEscapement := d;
  //LogRec.lfWeight := d; //@@@@@ very temoprary

  {* Create a new font handle using the modified old font handle *}
  NewFontHandle := CreateFontIndirect(LogRec);

  {* Save the old font handle! We have to put it back when we are done! *}
  OldFontHandle := SelectObject(c.Handle,NewFontHandle);

  {* Finally. Output the text! *}
  c.TextOut(x,y,s);

  {* Put the font back the way we found it! *}
  NewFontHandle := SelectObject(c.Handle,OldFontHandle);

  {* Delete the temporary (NewFontHandle) that we created *}
  DeleteObject(NewFontHandle);

end; {* CanvasTextOutAngle *}




Function CentralH(const Left,Right:integer;const S:string):integer;
{ return a horiz value so that the string S will be printed centrally.
  Note: This will trim the string if it is too long.
  uses the current settings for Printer.canvas fonts etc  }
var
  W : Integer;
  SS : String;
begin
  SS := S;
  W := Right-left;  // width
  while printer.canvas.textwidth(SS)>W do Ss := copy(SS,1,length(SS)-1);
  result := ((Left+Right)-printer.canvas.textwidth(SS)) div 2;
end;




Function CentralV(const Top,Bottom:integer; S:string):integer;
{ return a vertical value so that S will print vertically in the
  middle between the two }
begin
  result := ((Top+Bottom)-printer.canvas.textheight(S)) div 2;
end;




Function CheckTidyFloat(EB:TEdit):boolean;
{ 1) allow fractions in the edit box text - convert to decimal
  2) report true if this is a valid float}
var
  s : string;
  i : integer;
begin
  result := true;
  if cascade then exit else cascade := true;    // cascade protect
  TRY
    s := trim(EB.text);
    if s = '' then begin
      s := '0';
      result := true;           // valid as a number
    end else begin
      // any fractions?
      i := pos('/',s);
      if i<>0 then begin
        if i <> length(s) then begin
          if pos('1/2',s)<>0 then begin
            s := substr(s,' 1/2','.5');
          end else begin
            if pos('/4',s)<>0 then begin
              s := substr(s,' 1/4','.25');
              s := substr(s,' 3/4','.75');
            end else begin
              if pos('/8',s)<>0 then begin
                s := substr(s,' 1/8','.125');
                s := substr(s,' 3/8','.375');
                s := substr(s,' 5/8','.625');
                s := substr(s,' 7/8','.875');
              end else begin
                s := substr(s,' 1/16','.0625');
                s := substr(s,' 3/16','.1875');
                s := substr(s,' 5/16','.3125');
                s := substr(s,' 7/16','.4375');
                s := substr(s,' 9/16','.5625');
                s := substr(s,' 11/16','.6875');
                s := substr(s,' 13/16','.8125');
                s := substr(s,' 15/16','.9375');
              end;
            end;{1/4}
          end;{1/2}
          s := substr(s,' .','.');
        end;
      end;{any fractions}
      result := (StrToFloatdef(s,-1)>=0)
    end;
  FINALLY
    if s <> eb.text then begin
      eb.text := s;
      eb.selstart := length(s);
    end;
    application.processmessages;
    cascade := false;
  END;
end;




function chop(var Mainstring : string; const Chopper : string):string;
{ RETURNS THE FRONT OF A STRING IDENTIFIED BY THE SEPARATOR chopper.
  THE MAINSTRING IS CLIPPED SO THAT ONLY THE BACK END REMAINS.
  * Mainstring = '' ==> result = ''
  * Chopper = ''    ==> result = mainstring, mainstring=''
  * Chopper itself is lost and may be multi-character

  NB This is destructive to Mainstring
}

var
  silly:boolean;
  p : longint;
begin
  { trap exceptional cases }
  silly := false;
  if Mainstring = '' then
    begin
      result := '';
      silly := true;
    end;
  if Chopper = '' then
    begin
      result := Mainstring;
      mainstring := '';
      silly := true;
    end;
  if silly then exit;

 p := pos(Chopper,Mainstring);
 if p = 0 then
   begin       {not found so return rest}
     result := Mainstring;
     mainstring := '';
   end
 else
   result := copy(Mainstring,1,p-1);    {return LH as function result}
   p := p + length(chopper);            {skip chopper}
   if p > length(Mainstring) then       {trap terminal chopper}
     Mainstring := ''
   else                                 {lose LH from main string}
     Mainstring := copy(Mainstring,p,length(mainstring)-(p-1));
end;



{This way uses memory blocks for read/write.}




Function CommandPrinter(const Settings : Array of TPrinterSettings):Integer;
{ Talk to the printer (driver) direct
  Return the pixels per inch

  psLandscape,psPortrait                  Orientation
  psSimplex
  PsDuplexShort,psDuplexLong              The edge speced is the binding edge
  psUpper,psLower,psLargeCapacity          Source bins specified explicitly
  psPaperType1 )   NT only
  psPaperType2 )   Not yet implemented
  psPaperType3 )}




var
  Device : array[0..255] of char;
  Driver : array[0..255] of char;
  Port : array[0..255] of char;
  hDMode : THandle;
  PDMode : PDEVMODE;
  i,f,v : integer;
begin
  result := 0;                                        // keep compiler quiet
  application.processmessages;
  Printer.PrinterIndex := Printer.PrinterIndex;       // don't know why this is here
  Printer.GetPrinter(Device, Driver, Port, hDMode);
  if hDMode <> 0 then begin
    pDMode := GlobalLock(hDMode);
    if pDMode <> nil then begin
      for i := low(Settings) to high(Settings) do begin
        case Settings[i] of
          psLandscape       :begin f := dm_Orientation; v := DMORIENT_Landscape; end;
          psPortrait        :begin f := dm_Orientation; v := DMORIENT_Portrait;end;
          psSimplex         :begin f := dm_Duplex; v:= DMDUP_SIMPLEX; end;
          PsDuplexShort     :begin f := dm_Duplex; v:= DMDUP_HORIZONTAL; end;
          psDuplexLong      :begin f := dm_Duplex; v:= DMDUP_VERTICAL; end;
          psUpper           :begin f := dm_DefaultSource; v:= DMBIN_UPPER; end;
          psLower           :begin f := dm_DefaultSource; v:= DMBIN_LOWER; end;
          psLargeCapacity   :begin f := dm_DefaultSource; v:= DMBIN_LARGECAPACITY; end;
        else
          v := 0;
          f := 0;
        end;
        if f <>0 then begin
          pDMode^.dmFields := pDMode^.dmFields or f;
          case f of
            dm_orientation   : pDMode^.dmOrientation :=v;
            dm_DefaultSource : pDMode^.dmDefaultSource := v;
            dm_Duplex        : pDMode^.dmDuplex := v;
          end;
        end;
      end;
      result := trunc((pDMode^.dmLogPixels)/25.4) ;
      // @@@ this seems to always return 0 which is not what the book says
    end;
    GlobalUnlock(hDMode);
  end;
end;




function ConfirmBox(const Blurb:string):boolean;
{ return true if confirmed.
  Vertical bars in blurb act as CRLFs}
begin
  result := (mbox(application.handle,Blurb,'Confirmation required',4+32)=6);
end;




function DateData(const ADataSet:TDBDataset; Const AField:String; var DateResult:TDatetime):Boolean;
{Read the current record in ATable, indicated by AField and return a date.
NOTE The function returns a boolean indicating is there a real date here
The DATE ITSELF is returned via the third argument}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = $007 then begin
    result := true;
    Dateresult := v;
  end else begin
    result := false;
  end;
end;




procedure DateKeyService(EB: TEdit; var Key: Char);
{ take the key provided and try to do something }
var
  t : string;
  d : Tdatetime;
  okdate : boolean;
begin
  t := EB.text;
  okdate := readdate(t,d);
  case pos(key,'*+-.'+chr(13)) of
  0 : ; // do nothing - key falls throught
  1 : begin     // clear
        EB.text := '';
        key := chr(0);
      end;
  2 : if okdate then begin     // increase date by one day
        d := d + 1;
        EB.text := nicesmalldate(d);
        key := chr(0);
      end;

  3 : if okdate then begin     // decrease date by one day
        d := d - 1;
        EB.text := nicesmalldate(d);
        key := chr(0);
      end;
  4,5 : begin
          with eb.owner as TForm do begin
            activecontrol := TWincontrol(components[eb.componentindex+1]);
            key := chr(0);
          end;
        end;
  end;

  {VK_DECIMAL
  VK_DIVIDE
  VK_SUBTRACT
  VK_RETURN
  VK_ESCAPE}


end;




procedure delfile(const filename:string);
{Delete file as it should be.
  The official delphi version needs a poxy Pchar}
var
 pa : Pchar;
begin
  pa := stralloc(99);
  strpcopy(pa,filename);
  deletefile(pa);
  strdispose(pa);
end;




function dequote(const S: string):string;
{ remove any surrounding double quotes then trim}
begin
  Result := trim(SubStr(S,'"',''));
end;




Function DropZeros(const S:String):string;
{ lose 0's if thats all there is after the decimal point }
var
  i : Integer;
  D : String;
begin
  result := S;   // default = unchanged
  i := pos('.',S);
  if i > 0 then begin
    D := copy(S+'0',i,99);
    while copy(D,length(D),1)='0' do begin
      D := copy(D,1,length(D)-1);
    end;
    if D='.' then D:='';
    result := copy(S,1,i-1)+D;
  end;
  result := trim(result);
end;




Function EndOfTime:TDateTime;
{ return a date notionally representing the end of time}
begin
  result := encodedate(2049,12,21);
end;




  function ExtendedFileexists(var fname:string; trypath:string):boolean;
  {does the file exist?  If not then look in likely places before giving up.
    Look in trypath (if given being a std path format with ";" separation
    then look in the path of the currently executable.
    The FNAME argument is extended to the complete path if found}

  var
    fn : string;
    tp,p : string;
  begin
    result := true;
    if fileexists(fname) then exit;  {easy}

    {try the directory the program is located in}
    fn := extractfiledir(application.exename)+extractFilename(fname);
    if fileexists(fn) then begin
      fname := fn;
      exit;  {easy}
    end;

    {run through the path suggestions given in trypath}
    tp := trypath;
    result := false;
    while tp <> '' do begin
      p := chop(tp,';');                   {get next path in list to try}
      fn := p+'\'+extractFilename(fname);  {glue path and file name together}
      fn := substr(fn,'\\','\');                 {lose any duplicate slashes}
      if fileexists(fn) then begin
        fname := fn;
        result := true;
        break;  {while loop}
      end;
    end;
  end;{proc}




Function ExtractYear(const D:TDateTime):word;
{return the year portion of the date specified}
var
  yr,mo,dy:word;
begin
  decodedate(D,yr,mo,dy);
  result := yr;
end;




Procedure FlagEbGoodFloat(EB: TEdit; LA:TLabel; AllowZero:Boolean);
{ Check if the edit box text is a valid number
  if so then hide the label
  otherwise show the label

  If AllowZero is false then a value of 0 is illegal also

  The label is typically a red X}
var
  ok : boolean;
begin
  ok := checktidyfloat(eb);
  if ok then begin
    if (not allowzero) and (strtofloat(eb.text)=0) then ok := false;
  end;
  la.visible := not ok;
end;




procedure FlushTableBuffer(ATable: TTable);
{ forces a write of the current record of the table }
begin
  with ATable do begin
    if not active then exit;     // trap silly
    UpdateCursorPos;
    check(dbiSaveChanges(Handle));
    CursorPosChanged;
  end;
end;




function GetValue(const Slist:TStringList;key:string;var RHSide:string):boolean;
{Look up the key in the list provided.  This returns the rh side of the matched
 string in the parameter and returns FALSE if the key is not found.
 NB My convention is to have all keys in lowercase so if writing
 to such a list make sure that the keys are l/case!}
begin
  RHSide := Slist.values[lowercase(key)];
  result := (RHSide <> '');
end;




procedure HourGlass(const puton:boolean);
{ switch the hourglass on/off}
begin
  if puton then screen.cursor := crHourGlass else screen.cursor := crDefault;
  application.processmessages;
end;




Function HowWideShouldThisDBGridBe(const G:TDBGrid):integer;
{ calculate the ideal width for a TDBGRID }
var
  i,w : integer;
begin
  with g do begin
    if borderstyle = bsNone then w := 0 else w := 2;
    if dgColLines in Options then w := w + columns.count - 1;
    for i := 0 to columns.count-1 do w := w + columns.items[i].width;
  end;
  w := w + getsystemmetrics(sm_cxvscroll);
  result := w;
end;




procedure IncV(var V:integer; const S:string);
{ increment the vertical printing position by the height of the string
  if the string argument is null then use y as the basis }
var
  ss : string;
begin
  if s = '' then ss := 'y' else ss := s;
  v := v + printer.canvas.textheight(ss);
end;




function IndexofString(S:String;A : Array of string):integer;
{return the index of the 1st string in the array following
  example  INDEXOFSTRING(month,['Jan','Feb','Mar'])  }
var
  i : integer;
begin
  result := 0;
  for i := Low(A) to High(A) do begin
    if comparetext(S,A[i])=0 then begin
      result := i;
      break;
    end;
  end;
end;




function IntData(const ADataSet:TDBDataset; Const AField:String):integer;
{Read the current record in ATable, indicated by AField
and return an integer.  This is a wrapper that traps
null variants being returned and converts into 0}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if (vartype(v) = 2) or (vartype(v) = 3) then
    result := v
  else
    result := 0;
end;




Function IsAValidDate(const yr,mo,dy:Word):boolean;
{ Is this a valid date }
var
 y : word;
begin
  y := yr;
  if y = 0 then y := 1996;      // allow 0 for year leap year
  try
    encodedate(y,mo,dy);
    result := true;
  except
    result := false;
  end;
end;




function LoadQueryBySQL(var AQuery:Tquery; const S:string):integer;
{ Load SPECIFIED query component using the supplied sql
  return the number of records found }
begin
  application.processmessages;
  with AQuery do begin
    result := 0;
    close;
    sql.text := S;
    Hourglass(true);
    try
      open;
      result := recordcount;
    except
      on e : Exception do begin
        beep;
        okbox('SQL CODE FAILED|('+e.message+')|'+s);
      end;
    end;
  end;
  HourGlass(false);   // this will also do application.processmessages
end;




procedure Ltrim(var S:String);
{ remove leading spaces }
begin
  while S <> '' do
    if S[1]=' ' then
      S := copy(S,2,255)
    else
      break;
end;




procedure MakeBackupFile(const filename:string);
{ rename the specified file ...BAK
  deals with previous b/u versions
  and handles current not yet existing}
var
  ok : boolean;
  f : string;
begin
  ok := true;
  if fileexists(filename) then begin
    f := changefileext(filename,'.BAK');
    if fileexists(f) then ok := deletefile(f);
    ok := ok and renamefile(Filename,f);
    if not ok then alertbox('Trouble making a backup for '+filename);
  end;
end;




procedure MakeNodeVisible(var OL:Toutline;IX:Integer);
{ IX is an index of an item in outline OL.  We want to expand
all its parents.  It appears delphi isnt very good at performing
expand so we have to do it ourselves.}
begin
  with OL do begin
    if not items[IX].isvisible then begin
      makeNodevisible(ol,items[IX].parent.index);
      items[IX].parent.expand;
    end;
  end;
end;




function Maximum(const A: array of variant):variant;
{Returns the largest item in the array
  eg aFloat := Maximum([1.111,2.222,anotherFloat,aninteger]);}
var
  i : integer;
begin
  result := A[low(a)];
  for i := high(A) downto 1 do
    if result < A[i] then result := A[i];
end;




function MaxLineHeight(const C:Tcanvas):longint;
{ what is the maximum height of text on this canvas at present?
   Does a textheight of "y"}
begin
  Result := C.textheight('y');
end;




function mbox(const hand:Thandle;const Blurb,Title:string; Flags:word):Integer;
{ ENCAPSULATION OF MESSAGEBOX FUNCTION
  THIS GIVES US A TITLE AND USES PLAIN STRINGS
  ALSO REPLACE VERTICAL BARS WITH CRLFs
  Icons:  i ... 64      ! ... 48       ? ... 32       Stop ... 16
  Buttons:  OK ... 0  Cancel+OK ... 1  Yes+No...4   Yes+No+Cancel...3
  Result:  OK...1   Cancel...2   Yes...6   No...7
}

var
  B:string;
  PB,PT: pchar;
begin
  B := Substr(Blurb,'|',crlf);
  getmem(PB,length(B)+1);
  strpcopy(PB,B);
  getmem(PT,length(Title)+1);
  strpcopy(PT,Title);
  mbox := messagebox(hand,PB,PT,Flags);
  freemem(PB,length(B)+1);
  freemem(PT,length(Title)+1);
end;




Function MemoExtend(var aMemo:TMemo;MaxHeight:Integer):integer;
{ call this in a memo.OnChange event handler
  if the bottom of the memo is to be extended
  downwards/upwards to adjust to the amount of text.
  return the height in pixels of the memo
  MaxHeight limits the extent in pixels}

var
  nolines : integer;
  memheight : integer;
  li : longint;
begin
    //never used/altered := false;

    // adjust target no of rows of text
    nolines := aMemo.lines.count;
    if nolines < 1 then begin
      nolines := 1;
    end else begin
      if aMemo.lines[nolines-1] = '' then inc(nolines);
    end;

    // calculate the target height
    // (strangely "Ay" rather "y" works best for line hight calcs)
    memheight := (Tform(aMemo.Owner).canvas.textheight('Ay') * nolines);
    if memheight > MaxHeight then memHeight := MaxHeight;

    // possibly adjust
    if memheight <> aMemo.height then begin
      //never used/altered := true;
      aMemo.height := memheight;
      li := 0-aMemo.height;                {this is needed because the memo has a habit of}
      aMemo.perform(em_LineScroll, 0, li); {losing the top line so scroll up!!!}
    end;
    application.processmessages;
    result := memheight;

end;




function Minimum(const A: array of variant):variant;
{Returns the smallest item in the array
  eg aFloat := Maximum([1.111,2.222,anotherFloat,aninteger]);}
var
  i : integer;
begin
  result := A[low(a)];
  for i := high(A) downto 1 do
    if result > A[i] then result := A[i];
end;




Function NiceSmallDate(const D:TDateTime):string;
{ string representation of date in dd mmm yy format
  This is compatible with PARSEDATE()}
begin
  result := formatdatetime('dd mmm yy',D);
end;




Function NotAValidDate:TDatetime;
{ return a value which we deem to be a non-date (actually 30 dec 1899) }
begin
  result := 0;
end;




Function nthChild(const OL:Toutline;const ParentIx,ChildNo:integer):Integer;
{return the index of the nth child of the specified parent
 return -1 if ChildNo > no of children}
var
  i,c : integer;
begin
  if not OL.items[ParentIx].hasitems then begin
    Result := -1;  {fail on silly}
  end else begin
    c := ChildNo;                             {count down}
    i := OL.items[ParentIx].getfirstchild;    {ix of first child}
    c := c - 1;
    while c > 0 do begin
      i := OL.items[ParentIx].getnextchild(i);       {get the next child}
      if i = -1 then break;                   {but watch out for off the bottom}
      c := c - 1;                             {one less to do}
    end;
    result := i;
  end;
end;




function NullField(const ADataSet:TDBDataset; Const AField:String):boolean;
{ return true if the field specified is null }
begin
   result := (vartype(ADataset.fieldvalues[AField]) in [VarEmpty,VarNull]);
end;




procedure OKBox(const Blurb:string);
{ pause with message.   Vertical bars in blurb act as CRLFs}
begin
  mbox(application.handle,Blurb,'Note',64);
end;




function OneOfData(const ADataSet:TDBDataset; Const AField,TheOptions:String):integer;
{ AFIELD (possibly) contains a single character.
  TheOptions is a set of characters we are testing against
  We return the position in these options *** starting at 1 ***
  eg
     case OneOfData(aTable,'TrafficLight','RAG') of   //red-amber-green
     ...
  This returns 0 if the field is empty or not one of the options.
  Case sensitive}
var
  s : string;
begin
  s := strdata(AdataSet,AField);
  result := 0;
  if s <> '' then result := pos(s,TheOptions);
end;




Function ParseDate(const DS: String; var dy,mo,yr:word):boolean;
{ convert the string to a date
  if ABLE TO PARSE then return true
  if YR is missing from string but >=0 when called then this is substituted 69->2069 70->1971
  if YR is missing from string but <0 then substitute current year

  Format of date string:
  1) Short string format
  -------------------------------------------
  <day><separator><month>[<separator><year>]
  where:
  <day> is one or two digits - allow leading zero
  <separator> is one of space,slash or minus
  <month> is one or two digits or a month neme or abbreviated month name
  <year> (if present) is two or 4 digits.  If 2 digits then use the hundreds
    from the YR argument when initially called

  2) Compact numeric format
  -------------------------------------------
  Always six digits ddmmyy
}

var
  DT : TDateTime;
  a : array[0..8] of string;
  dasi,nof : integer;
  s : string;
begin

  // can we treat this as a compact date of six digits?
  // --------------------------------------------------
  if length(ds)=6 then begin
    dasi := strtointdef(ds,0);
    if (dasi >= 10100) and (dasi <= 311299) then begin
      yr := dasi mod 100;
      dasi := (dasi - yr) div 100;
      mo := dasi mod 100;
      dasi := (dasi - mo) div 100;
      dy := dasi;
    end;
  end else begin
    // looks like we have a day number month name and year number
    // ----------------------------------------------------------
    // parse the string
    nof := Stringtoarray(DS,'-/ ',a);
    if nof < 2 then begin
      result := false;
      exit;
    end;

    // day
    dy := strtointdef(a[0],0);
    if ((dy < 0) or (dy>31)) then begin
      result := false;
      exit;
    end;

    // month
    s := copy(uppercase(a[1])+'  ',1,3);
    mo := strtointdef(trim(S),0);
    if mo =0 then begin      // looks like a month name
      if (s='JAN') or (S='JA ') then mo := 1 else
       if (s='FEB') or (S='FE ') then mo := 2 else
        if (s='MAR') or (S='MR ') then mo := 3 else
         if (s='APR') or (S='AP ') then mo := 4 else
          if (s='MAY') or (S='MY ') then mo := 5 else
           if (s='JUN') or (S='JE ') then mo := 6 else
            if (s='JUL') or (S='JY ') then mo := 7 else
             if (s='AUG') or (S='AU ') then mo := 8 else
              if (s='SEP') or (S='SE ') then mo := 9 else
               if (s='OCT') or (S='OC ') then mo := 10 else
                if (s='NOV') or (S='NO ') then mo := 11 else
                 if (s='DEC') or (S='DE ') then mo := 12;
    end;
    if (mo<1) or (mo>12) then begin
      result := false;
      exit;
    end;


    // 3 fields needed to have a chance of a date
    if nof >= 3 then begin
      yr := strtointdef(a[2],-1);
      if yr = -1 then begin
        result := false;
        exit;
      end;
    end;

  end;

  // we now have dy,mo and yr but yr might be two digits
  if yr < 100 then begin
    if yr < 57 then yr := yr + 2000 else yr := yr + 1900;
  end;

  // validate the date
  try
    DT := encodedate(Yr,mo,dy);
    result := true;
  except
    result := false;
  end;

end;




procedure pdecimal(const H,V:integer; DecimalString:string);
{ print a decimal number with the decimal point aligned at H
  S should contain a decimal point.  If not then it will be right justified to the point position}
var
  S : String;
  i : integer;
begin
  S := DecimalString;
  with printer.canvas do begin
    i := pos('.',S);                 // find the point
    if i > 0 then begin
      textout(H,V,copy(S,i,999));     // print the tail
      S := copy(S,1,i-1);
    end;
    i := H - textwidth(S);           // print the head
    textout(i,V,S);
  end;
end;




Function PenceToSterling(const Pence:Integer):string;
{ return a nicely formatted currency string }
var
  neg : boolean;
  p , quids : integer;
begin
  if pence=0 then begin
    result := '0.00';
  end else begin
    neg := (pence < 0);
    p := abs(pence);
    quids := p div 100;
    p := p - (quids * 100);
    if quids < 1 then begin
      result :=  inttostr(Pence)+'p';
    end else begin
      result := format('%d',[quids])+'.'+format('%2.2d',[p]);
      if neg then result := '-'+result;
      //result := '' + result;
    end;
  end;
end;




function pix(const mm:integer):integer;
{ convert mm to pixels
  NB assumes that the same printer is used throughout the program
  as the first time we use it we ask the printer to tell us -
  then it is stores for ready use

  SO IF YOU CHANGE PRINTERS USE A SPECIAL VERSION OF THIS FUNCTION
  TO FORCE A REFRESH OF THE CURRENT PRINTER PIXEL TO MM RATIO:
  CALL WITH A NEGATIVE ARGUMENT.

  eg 1st time you're printing a document after a possible printer
  (re)selection use X:=pix(0-Y) rather than X:=pix(Y)}
begin
  // first time get the info from the printer driver

  if ((mmtopixel < 1) or (mm<1)) then begin
    mmtopixel := getdevicecaps(Printer.handle,LOGPIXELSX)/25.4;
  end;
  result := trunc(mmtopixel * abs(mm));
end;




procedure pline(const H:integer; var V:integer; const S:string);
{ print out a string at the H and V pixel positions.
  increase V by the height of the text}
begin
  with printer.canvas do begin
    textout(H,V,S);
    V := V + textheight(S);
  end;
end;




procedure pout(const H,V:integer; S:string);
{ print out a string at the H and V pixel positions.}
begin
  with printer.canvas do begin
    textout(H,V,S);
  end;
end;




procedure poutonline(const H,V:integer; S:string);
{ textout function but with the V being the font base line not the top }
begin
  printer.canvas.textout(H,AlignBaseV(V,S),S);
end;




function ProgramNameAndDate:String;
{ return the name of the EXE file and the compilation time stamp}
var
 S,fs : String;
 fd : integer;
 ft : TDateTime;
begin
  s := application.exename;
  fd := fileage(s);
  ft := FileDateToDateTime(fd);
  fs := formatdatetime('d-mmm-yy hh:nn',ft);
  result := S + '('+fs+')';
end;




procedure pwrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ wrap the text within the limits H1 and H2
  Increase the Vertical position V to the next free line
  Any "[..]" will result in a new line
  "[PARA]" will result in a new paragraph}
var
  T,S : String;
begin
  T := ToBeWrapped;
  // need to do tricks with text as we may have [PARA] and/or [NEWLINE] embeds
  while T <> '' do begin
    S := chop(T,'[');
    _pwrapline(H1,H2,V,S);
    if T = '' then break;   // no remaining special commands
    S := chop(T,']');       // S<--command T<--remainder of text
    if pos('PARA',S)<>0 then V := V + pix(4);   // add some vertical white space
  end;
end;




Function pwrappingheight(const H1,H2:integer; const ToBeWrapped:string):integer;
{ return the height that would be used if the text was wrapped
  in these limits}
var
  V : Integer;
begin
  wrapisadummy := true;   // stop actual printing
  V := 0;
  pwrap(H1,H2,V,ToBeWrapped);
  wrapisadummy := false;
  result := V;
end;




function PX:integer;
{ printer position in pixels across page }
begin
  result := printer.canvas.penpos.X;
end;




function PY:integer;
{ printer position in pixels down page }
begin
  result := printer.canvas.penpos.Y;
end;




Function ReadDate(Const DS:String; var DT:TDateTime):Boolean;
{ Convert string to date. See PARSEDATE}
var
  dy,mo,yr : word;
begin
  // we might be using YR in PARSEDATE
  try
    decodedate(dt,yr,mo,dy);
  except
    decodedate(date,yr,mo,dy);
  end;
  // parse the date
  result := Parsedate(ds,dy,mo,yr);
  // convert parts into a TDateTime
  if result then  DT := encodedate(yr,mo,dy);
end;




Function ReadIniDetail(const IniFile,Section,Key : string):string;
{read a particular bit from the ini file}
var
 i : string;
 sl : TStringList;
begin
  i := inifile;
  sl := TStringList.create;
  try               {preoect against memory leak with SL}
     if readinisection(i,Section,sl) then begin
       result := sl.values[key];
     end else begin
       result := '';
     end;
  finally
    sl.free;
  end;
end;{proc}




function ReadIniSection(var   IniFileName : string;
                        const SectName    : string;
                        var   SList       : TStringList) : boolean;
{ read the ini file
  return true if successfull else false
  the whole section is in sList
  extract an element with Slist.values['key_string'] (built-in)
  or GetValue(slist,key,rhside)-->boolean (part of this module)

  If inifileName is given as '' then we'll try to use the name of the executable as a guide.
  If inifilename is not found then we'll look in the executable directory.
  The ini file will be returned as a complete filename if found.

  NB
    To avoid probs with text matches:
      all spaces are removed
      LH side case is smashed to lowercase}
var
  ini : TIniFile;
  s : string;
  i,p : integer;
begin
slist.clear;

  {locate the file}
  {===============================================================================}
  if not fileexists(inifilename) then begin   {try the simple things first}
    if IniFileName = '' then begin            {use the exec name as basis of ini file}
      IniFileName := changefileext(application.exename,'.ini');
    end else begin                            {or just the path of the executable}
      IniFileName := extractfiledir(application.exename)+'\'+extractfilename(inifilename);
    end;
    if not fileexists(inifilename) then begin   {give up}
      mbox(application.handle,'File not found','Looking for the file|'+inifilename,48);
      result := false;
      exit;
    end;
  end;
  {inifiles need fully expabnded names to work - shame about the documentation!}
  inifilename := expandfilename(inifilename);


  {create the TiniFile, load the list with data and destroy the Tinifile}
  {===============================================================================}


    ini := Tinifile.create(inifilename);
    slist.clear;
    try   {protect against memy leak}
      ini.readsectionvalues(SectName,Slist);
    finally
      ini.free;
    end;
    result := (SList.count<>0);  {fail if no strings loaded = section not found}

    {tidy up all the strings we have been given}
    {===============================================================================}
    {make sure that the "=" doesn't have any surrounding spaces.
    this is required when we use .VALUE on the list.  As we don't need
    any spaces lose the lot.  And lets make the key lowercase for safety.
    Lose any trailing comments.}
    if result then begin
      for i := 0 to slist.count -1 do begin
        s := substr(slist.strings[i],' ','');  {lose all spaces}
        s := substr(slist.strings[i],#8,'');   {lose all tabs}
        p := pos(';',s);        {start of comment}
        if p > 0 then s := copy(s,1,p-1);
        p := pos('=',s);        {end of key}
        if p > 0 then s := lowercase(copy(s,1,p))+copy(s+' ',p+1,length(s)-p);
        slist.strings[i] := s;
      end;
    end;{if result = true}
end;{proc}




function RectHeight(R:Trect):longint;
{ height of a Rectangle }
begin
  RectHeight := 1+ R.bottom - R.top;
end;




Function RectWidth(R:Trect):longint;
{ width of a rectangle }
begin
  RectWidth := 1+ R.Right - R.Left;
end;




function rightStr(const S:string; const L:longint) : String;
{ RETURN THE RIGHT PART OF A STRING }
var
  i : longint;
begin
  if (S = '') or (L = 0) then
    rightstr := ''
  else
    begin
      i := length(S) + 1 - L;
      if i < 1 then i := 1;
      rightstr := copy(S,i,L);
    end;
end;




procedure Rtrim(var S:String);
{ remove trailing spaces }
begin
  while S <> '' do
    if S[length(S)]=' ' then
      S := copy(S,1,length(S)-1)
    else
      break;
end;




Function SelectNamedPrinter(Const Pname:string):boolean;
{ attempt to select a printer by name
  The name given only has to appear somewhere in the
  name of the printer
  return true if found and selected}
var
  i : integer;
begin
  result := false;
  with printer.printers do begin
    for i := 0 to count-1 do begin
      if pos(uppercase(pname),uppercase(strings[i]))<>0 then begin
        result := true;
        printer.printerindex := i;
        break;
      end;
    end;
  end;
end;




procedure setfont(const fName:string;fSize:integer);
{ quickly set the printer font
  A blank or 0 is no change for that parameter
  Fname can be a virtual font which means that if we get slightly
  different font names on a target operating system we can
  tweak the names (by hard coding) here.
  Also we can modify style throughout printing.
  negative FSIZE gives italics
  fsize + 100 gives bold
  Values: "*TIMES","*COURIER","*ARIAL",
          "*STONE",      (GM Stone Sans)
          "*STONEBOLD",  (GM Stone Sans Semi-bold)
          "*SMALL","*HEADING",}
var
  fs : integer;
  bold,italic:boolean;
  fn : string;
begin
  fn := fname; // convert to working variables
  fs := fsize;

  bold := (pos('<B>',fn)<>0);
  if bold then fn := substr(fname,'<B>','');
  italic := (pos('<I>',fn)<>0);
  if italic then fn := substr(fname,'<I>','');

  if fn = '*TINY' then begin fn := '*ARIAL' ; fs := 6; end;
  if fn = '*SMALL' then begin fn := '*ARIAL' ; fs := 8; end;
  if fn = '*HEADING' then begin fn := '*TIMES' ; fs := 18; end;
  if fn = '*TIMES' then fn := 'Times New Roman';
  if fn = '*ARIAL' then fn := 'Arial';
  if fn = '*COURIER' then fn := 'Courier New';
  if fn = '*STONE' then fn := 'StoneSans';
  if fn = '*STONEBOLD' then fn := 'StoneSansSemibold';

  with printer.canvas do begin
    with font do begin

      if fn <> '' then begin
        name := fn;
        if name <> fn then alertbox('Unable to change font to "'+fn+'"');
      end;

      if fsize = 0 then size := fs else size := fsize;

      style := [];
      if italic then style := style + [fsItalic];
      if bold then style := style + [fsBold];

    end;
  end;

end;




function SingleData(const ADataSet:TDBDataset; Const AField:String):Single;
{Read the current record in ATable, indicated by AField
and return a single.  This is a wrapper that traps
null variants being returned and converts into 0}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if (vartype(v) = 4) or (vartype(v) = 5) then
    result := v
  else
    result := 0;
end;




function SLData(const ADataSet:TDBDataset; Const AField:String; var SL:TStringList):Boolean;
{ read the current record in ADataSet
  Try to fill the string list with text from a memo field (could be a string)
  return false if there is no text }
begin
  try
    SL.text := ADataset.fieldvalues[AField];
    result := true;
  except
    result := false;
  end;
  if result then result := length(SL.text)>0;
end;




procedure SortOutline(var OL:Toutline;const ix:integer);
{sort the immediate children of this item in the outline.
It might be a good to hide the outline before sorting}

var
  firstix,lastix,i,prv,childcount: integer;
begin
{method:
  We look to see if selected items need to be bumped up.
  We firstly select child 2 and compare with 1st then
  3rd with second which may trigger 2nd and 1st
  then 4th/3rd ... 3rd/2nd ...2nd/1st}
  if not OL.items[ix].hasitems then exit;   {silly}
  firstix := OL.items[ix].getfirstchild;
  if firstix = -1 then exit;                {odd but no first child}
  lastix := OL.items[ix].getlastchild;
  if firstix = lastix then exit;            {only one child}
  childcount := 1;
  while true do begin                       {loop, increasing last to look at}
    inc(childcount);
    i := nthChild(OL,IX,childcount);        {if beyond last child then i <- -1}
    if i = -1 then break;
    while i > firstix do begin              {i = ix of item we might bump up}
      prv := OL.items[ix].getprevchild(i);   {and it's previous mate}
      if prv < 1 then break;                {catch silly}
      if compareText(OL.items[i].text,OL.items[prv].text) < 0 then begin
        {swap}
        ol.beginupdate;
        OL.items[i].moveto(prv,oaInsert);
        ol.endupdate;
        i := prv;
      end else begin
        {no need to swap...since all lower are sorted we can quit}
        i := -1;  {flag quit}
      end;
    end;{inner loop bumping last item up until it settles in sorted position}
  end;{outer loop working our way down the children}
end;{proc}




Function SQLCopyRecords(Destination:TTable; CopyMode: TBatchMode;
                        const SQL:String;SourceDatabase:TDatabase):integer;
{ This is a bit like the TBatchMove and actually performs BatchMove
  What we're doing is hiding the query used as the intermediate stage
  Also we're assuming that the records are the same format

  See BatchMove for details of CopyMode argument
  SQL is a select statement applied to the SourceDatabase

  example:
    if SQLCopyRecords(OneTable,batAppend,s,DBLive) = 0 then showmessage(S + 'Copied no records')}
var
  q : TQuery;
begin
  q := TQuery.create(application);
  TRY
    try
      q.databasename := SourceDatabase.DatabaseName;
      result := Loadquerybysql(q,SQL);
      if result > 0 then Destination.batchmove(q,BatAppend);
    except
      on e : Exception do
        alertbox('ERROR|SQLCopyRecordsFailed|Dest='+Destination.TableName+'|SQL='
                +sql+'|Database='+Sourcedatabase.Databasename
                +'|'+e.message);
    end;
  FINALLY
    q.free;
  END;
end;




function SQLCount(var AQuery:Tquery; const S:string):integer;
{ this executes a sql query which is in the form of
  SELECT COUNT(xxx) FROM ... (or SUM,MIN,MAX or AVG etc)
  The single value is then returned}
var
  ok : boolean;
begin
  result := 0;

  // simple input arg checks
  ok := pos('COUNT(',uppercase(s))<>0;
  if not ok then ok := pos('SUM(',uppercase(s))<>0;
  if not ok then ok := pos('AVG(',uppercase(s))<>0;
  if not ok then ok := pos('MIN(',uppercase(s))<>0;
  if not ok then ok := pos('MAX(',uppercase(s))<>0;
  if not OK then begin
    alertbox('SQLCOUNT ERROR|Not an aggregate query');
    exit;
  end;

  // execute the query and check we only have one row returned
  if loadquerybysql(AQuery,S) <> 1 then begin
    alertbox('SQLCOUNT ERROR|More than one row returned');
    exit;
  end;

  try
    result := aquery.fields[0].asinteger;
  except
    alertbox('SQLCOUNT ERROR|Odd result type');
  end;

end;




Function SQLDate(Const D:TdateTime):string;
{ format the date so that it is acceptable as an input
  argument in a SQL query}
begin
  result := '"'+ uppercase(formatdatetime('dd"-"mmm"-"yyyy',D))+'"';
end;




function StrData(const ADataSet:TDBDataset; Const AField:String):string;
{Read the current record in ATable, indicated by AField
and return a string.  This is a wrapper that traps
null variants being returned and converts into ''}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = $001 then
    result := ''
  else
    result := v;
end;




Function StringToArray(const S,chopper:String;  var A : Array of string):integer;
{ split the string into words as defined by the characters in chopper
  return the number of strings in the array
  return -ve if busted string array limit

  example:  nofields := StringToArray(CSVSTRING,'",',flds); }
var
  c : string;
  ns,i : integer;
begin
  result := 0;
  if S = '' then exit;       // nothing in the string
  if chopper='' then begin   // silly no chopper characters
    result := -1;
    a[low(a)] := S;
    exit;
  end;

  ns := low(a);
  a[ns]:= '';
  for i := 1 to length(s) do begin
    c := copy(S,i,1);
    if pos(c,chopper)<>0 then begin
      if a[ns]<>'' then begin        // marks the end of something previous
        inc(ns);
        if ns > high(a) then begin   // trap busted array bounds
          result := 0-(ns-1);
          break;
        end;
        result := ns;
        a[ns]:='';                   // clear next array element
      end;
    end else begin
      a[ns]:= a[ns]+c;
    end;
  end;
  // special case where last thing read was a chopper character
  if result > 0 then begin
    if a[result] = '' then result := result - 1;
  end;

  // return the NUMBER of strings which is 1 more than HIGHEST used
  if result > 0 then  result := result + 1;
end;




function StrToFloatDef(const S:string;const F:Extended):Extended;
{ traps conversion error internally.
  Behaves as StrToIntDef()}
begin
  try
    Result := strtofloat(s);
  except
    Result := F;
  end;
end;




function SubStr(const S:string; const ToBeRepl:string; const ReplBy:string):string;
{ Replace one substring by another
  S : String           Host string.  REMAINS UNCHANGED
  ToBeRepl : String    To be removed
  ReplBy : String      To be substituted

  NOTE  Circular substitutions are allowed.
        If TobeRepl is null then result is S unchanged

  How to remove a whole set of characters:
    invalidchars := '/\?.:* ,';:#][=-+$^&"!%');
    for i := 1 to length(Invalidchars) do
        s := substr(s,InvalidChars[i],'');}


var
  W,X : string;
  p,ld: longint;
begin
  if ToBeRepl = '' then SubStr := S;    { trap sillies }
  if ToBeRepl = '' then exit;
  W := '';
  X := S;
  ld := length(ToBeRepl);

  {@@@ needs some trap of making a string too long }
  while X <> '' do
    begin
      p := pos(ToBeRepl,X);
      case p of
        0 : begin
             W := W + X;
             X := '';
            end;
        1 : begin
             W := W + ReplBy;
             X := copy(X,ld+1,length(X)-ld);
            end;
      else
            begin
              W := W + copy(X,1,p-1) + ReplBy;
              X := copy(X,p+ld,255)
            end;
      end;
    end;
   Substr := W;
end;




Function SubStrip(const S,ToStrip,ToSub:string):string;
{ multiple SUBSTR.  Typically used to strip a number of characters at a time.
  S       : String    Original
  ToStrip : String    Strings split by vertical bars to be replaced
  ToSub   : String    String to replace

  Example:   TidyStr := SubStrip(Str,' |.|,','');
             This would remove spaces, periods and commas completely
             }
var
  a,b,c : string;
begin
  b := s;
  a := Tostrip;
  while a <> '' do begin
    c := chop(a,'|');
    b := substr(b,c,ToSub);
  end;
  result := b;
end;




procedure tActivate(aTable:TTable);
{ put the table into the active state}
begin
  with aTable do begin
    if state = dsinactive then open;
  end;
end;




procedure tDeActivate(aTable:TTable);
{ put the table into the inactive active state
  if necessart call post first}
begin
  with aTable do begin
    if state in [dsedit,dsinsert] then post;
    application.processmessages;
    if state <> dsinactive then close;
  end;
end;




function TFData(const ADataSet:TDBDataset; Const AField:String):boolean;
{Read the current record in ATable, indicated by AField
and return a boolean.  This is used on fields that are single
character fields used for boolean data 'T'=True any other=false
(because Paradox's "Logical" field type can't be used for
filtering)}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = $001 then
    result := False
  else
    result := ((string(v)='T')or(string(v)=DBTRUE));
end;



{**********************************************************}




Procedure Trap;
{This will normally do nothing but can be set to do anything you like
 eg showmessage.  But really for switching on multiple breaks in one point}
begin
    ;  {do nothing!!}
end;




Function TrimString(const S:String):String;
{return trimmed string}
var r : string;
begin
  r := s;
  ltrim(r);
  rtrim(r);
  result:=r;
end;




function TryEdit(aTable:TTable):boolean;
{ A wrapper round the EDIT method.  This will trap locks and allow us to
  try again etc.  Return false if we can't get to editing the table }
var
  again : boolean;
begin
  again := false;
  repeat
    begin
      try
        atable.edit;
      except
        on e: EDatabaseError do begin
          again := confirmbox('TROUBLE ACCESSING A RECORD IN '
                  +atable.tablename
                  +'|TRY AGAIN?|('
                  +e.message+')');
        end;
      end;
    end;
  until not again;
  result := (atable.state = dsedit);
end;




Function TW(const S:string):integer;
{ shorthand for Printer.canvas.textwidth function }
begin
  result := Printer.canvas.textwidth(S);
end;




procedure uFileCopy(const FromFile, ToFile: string);
{ COPY A FILE }
 var
  FromF, ToF: file;
  NumRead, NumWritten: Integer;
  Buf: array[1..1024] of Char;
begin
(*  showmessage('filecopy');  {@@@}
  exit;
*)

  AssignFile(FromF, FromFile);
  Reset(FromF, 1);		{ Record size = 1 }
  AssignFile(ToF, ToFile);	{ Open output file }
  Rewrite(ToF, 1);		{ Record size = 1 }
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    BlockWrite(ToF, Buf, NumRead, NumWritten);
  until (NumRead = 0) or (NumWritten <> NumRead);

  System.CloseFile(FromF);
  System.CloseFile(ToF);
end;




Function UnCapitialise(const S:String):string;
{ turn words that are completely capitialised into proper names
  eg SMITH --> Smith }
var
  c : string;
  i : integer;
  u : boolean;
begin
  u := true;
  result := '';
  for i := 1 to length(S) do begin
    c := copy(s,i,1);
    if u then result := result+c else result := result + lowercase(c);
    u := false;
    if c < 'A' then u:=true;
  end;
end;




procedure UpdateStrData(var ATable:TTable; Const AField,NewData:string;const EraseOnly:Boolean);
{ if the new value is different then update
  Make sure we're not duplicating
  ATABLE .... Name of a table
  AFIELD .... Name of a string field
  NEWDATA ... String to make the current record, named field
  If ERASEONLY is true then if the string is already present then remove it}
var
  s,t : string;
  changed : boolean;
begin
  if newdata = '' then exit;                         // nothing to do
  s := strdata(ATable,AField);                       // read existing
  if s <> '' then t := substr(s,Newdata,'');         // possibly remove a previous copy
  changed := (s<>t);                                 // flag the change
  if changed then s := t;
  if not eraseonly then begin
    s := s + newdata;            // add new stuff
    changed := true;
  end;
  if changed then begin
    with ATable do begin
      if tryedit(ATable) then begin;
        fieldvalues[AField]:=NewData;
        post;
      end;
    end;
  end;
end;




function ValidVariant(const V:Variant):boolean;
{ return false if argument is null or empty}
begin
   result := not(varisempty(V) or varisnull(V));
end;




function Vscrollwidth:Longint;
{ HOW MANY PIXELS WIDE IS THE VERTICAL SCROLL BAR?}
begin
     result := GetSystemMetrics(SM_CXHTHUMB);
end;




Function WhereOrAnd(const SQL,Condition:string):string;
{ We often want to add conditions to a WHERE expression
  of an SQL statement.  We can get into a bit of a twist
  with multiple conditions.  This ensures there is one
  WHERE and any subsequent are ANDs

  Returns the combination of SQL + Condition with
  the appropriate WHERE or AND in between}
var
  con : string;
begin
  con := ' WHERE ';
  if pos('where',lowercase(SQL)) <> 0 then con := ' AND ';
  result := SQL + con+ '(' + condition+ ') ';
end;




procedure WrapIntoGridCell(Sender: TObject; C, R: Longint;
  Rect: TRect; State: TGridDrawState);
{the sort of thing where we have multi line displays for
 displaying in a grid.  Actually the wrap only works
 with hard returns ie #13+#10}
var
  V : integer;
  nl,S,T :String;
begin
  nl := #13+#10;
  with sender as TStringGrid do begin
    S := cells[c,r];
    // lose any trailing New Line
    if length(s)>=2 then begin
      if copy(S,length(S)-1,2)=nl then S := copy(S,1,length(S)-2);
    end;
    V := rect.top;
    with canvas do begin
      fillrect(rect);
      while S <> '' do begin
        T := chop(S,nl);
        textout(rect.left,V,T);
        V := V + Textheight(T);
      end;
    end;
    if (V-rect.top) > rowheights[r] then rowheights[r] := V-rect.top;
  end;
end;

end.






(*  Usage comments extracted on 22/12/1998 21:18:43
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************
************************************************************

---------------------------------------------------------------------------
procedure _pwrapline(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ private - wraps a single line without any formatting characters }

---------------------------------------------------------------------------
procedure AlertBox(const Blurb:string);
{ pause with message.   Vertical bars in blurb act as CRLFs}

---------------------------------------------------------------------------
Function AlignBaseV(const VBaseLine:integer;S:string):integer;
{ return a vertical value so that the baseline of the text will print
  at the VBASELINE position}

---------------------------------------------------------------------------
Function BegOfTime:TDateTime;
{ return a date notionally representing the beginning of time}

---------------------------------------------------------------------------
procedure CanvasSetTextAngle(c: TCanvas; d: Word);
{-----------------------------------------------------------
  PURPOSE
    To change the current text output rotation angle. All
    subsequent output will be at the angle provided.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.
    d - The angle in tenths of degrees. For example 10 would
      be 1 degree. 450 would be 45 degrees. 1 would be
      1/10 of a degree. To reset the text back to normal,
      make d = 0.

  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}

---------------------------------------------------------------------------
procedure CanvasTextOutAngle(c: TCanvas; x,y: Integer; d: Word; s: string);
{-----------------------------------------------------------
  PURPOSE
    To output rotated text in the same font as the font on
    the supplied canvas. The font must also be a scaleable
    font.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.

    x,y - The x,y screen coordinates you would normally
      supply the TextOut procedure.
    d - The angle in tenths of degrees. For example 10 would
      be 1 degree. 450 would be 45 degrees. 1 would be
      1/10 of a degree.
    s - The text to be output to the canvas.
  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}

---------------------------------------------------------------------------
Function CentralH(const Left,Right:integer;const S:string):integer;
{ return a horiz value so that the string S will be printed centrally.
  Note: This will trim the string if it is too long.
  uses the current settings for Printer.canvas fonts etc  }

---------------------------------------------------------------------------
Function CentralV(const Top,Bottom:integer; S:string):integer;
{ return a vertical value so that S will print vertically in the
  middle between the two }

---------------------------------------------------------------------------
Function CheckTidyFloat(EB:TEdit):boolean;
{ 1) allow fractions in the edit box text - convert to decimal
  2) report true if this is a valid float}

---------------------------------------------------------------------------
function chop(var Mainstring : string; const Chopper : string):string;
{ RETURNS THE FRONT OF A STRING IDENTIFIED BY THE SEPARATOR chopper.
  THE MAINSTRING IS CLIPPED SO THAT ONLY THE BACK END REMAINS.
  * Mainstring = '' ==> result = ''
  * Chopper = ''    ==> result = mainstring, mainstring=''
  * Chopper itself is lost and may be multi-character

  NB This is destructive to Mainstring
}


---------------------------------------------------------------------------
Function CommandPrinter(const Settings : Array of TPrinterSettings):Integer;
{ Talk to the printer (driver) direct
  Return the pixels per inch

  psLandscape,psPortrait                  Orientation
  psSimplex
  PsDuplexShort,psDuplexLong              The edge speced is the binding edge
  psUpper,psLower,psLargeCapacity          Source bins specified explicitly
  psPaperType1 )   NT only
  psPaperType2 )   Not yet implemented
  psPaperType3 )}





---------------------------------------------------------------------------
function ConfirmBox(const Blurb:string):boolean;
{ return true if confirmed.
  Vertical bars in blurb act as CRLFs}

---------------------------------------------------------------------------
function DateData(const ADataSet:TDBDataset; Const AField:String; var DateResult:TDatetime):Boolean;
{Read the current record in ATable, indicated by AField and return a date.
NOTE The function returns a boolean indicating is there a real date here
The DATE ITSELF is returned via the third argument}

---------------------------------------------------------------------------
procedure DateKeyService(EB: TEdit; var Key: Char);
{ take the key provided and try to do something }

---------------------------------------------------------------------------
procedure delfile(const filename:string);
{Delete file as it should be.
  The official delphi version needs a poxy Pchar}

---------------------------------------------------------------------------
function dequote(const S: string):string;
{ remove any surrounding double quotes then trim}

---------------------------------------------------------------------------
Function DropZeros(const S:String):string;
{ lose 0's if thats all there is after the decimal point }

---------------------------------------------------------------------------
Function EndOfTime:TDateTime;
{ return a date notionally representing the end of time}

---------------------------------------------------------------------------
  function ExtendedFileexists(var fname:string; trypath:string):boolean;
  {does the file exist?  If not then look in likely places before giving up.
    Look in trypath (if given being a std path format with ";" separation
    then look in the path of the currently executable.
    The FNAME argument is extended to the complete path if found}


---------------------------------------------------------------------------
Function ExtractYear(const D:TDateTime):word;
{return the year portion of the date specified}

---------------------------------------------------------------------------
Procedure FlagEbGoodFloat(EB: TEdit; LA:TLabel; AllowZero:Boolean);
{ Check if the edit box text is a valid number
  if so then hide the label
  otherwise show the label

  If AllowZero is false then a value of 0 is illegal also

  The label is typically a red X}

---------------------------------------------------------------------------
procedure FlushTableBuffer(ATable: TTable);
{ forces a write of the current record of the table }

---------------------------------------------------------------------------
function GetValue(const Slist:TStringList;key:string;var RHSide:string):boolean;
{Look up the key in the list provided.  This returns the rh side of the matched
 string in the parameter and returns FALSE if the key is not found.
 NB My convention is to have all keys in lowercase so if writing
 to such a list make sure that the keys are l/case!}

---------------------------------------------------------------------------
procedure HourGlass(const puton:boolean);
{ switch the hourglass on/off}

---------------------------------------------------------------------------
Function HowWideShouldThisDBGridBe(const G:TDBGrid):integer;
{ calculate the ideal width for a TDBGRID }

---------------------------------------------------------------------------
procedure IncV(var V:integer; const S:string);
{ increment the vertical printing position by the height of the string
  if the string argument is null then use y as the basis }

---------------------------------------------------------------------------
function IndexofString(S:String;A : Array of string):integer;
{return the index of the 1st string in the array following
  example  INDEXOFSTRING(month,['Jan','Feb','Mar'])  }

---------------------------------------------------------------------------
function IntData(const ADataSet:TDBDataset; Const AField:String):integer;
{Read the current record in ATable, indicated by AField
and return an integer.  This is a wrapper that traps
null variants being returned and converts into 0}

---------------------------------------------------------------------------
Function IsAValidDate(const yr,mo,dy:Word):boolean;
{ Is this a valid date }

---------------------------------------------------------------------------
function LoadQueryBySQL(var AQuery:Tquery; const S:string):integer;
{ Load SPECIFIED query component using the supplied sql
  return the number of records found }

---------------------------------------------------------------------------
procedure Ltrim(var S:String);
{ remove leading spaces }

---------------------------------------------------------------------------
procedure MakeBackupFile(const filename:string);
{ rename the specified file ...BAK
  deals with previous b/u versions
  and handles current not yet existing}

---------------------------------------------------------------------------
procedure MakeNodeVisible(var OL:Toutline;IX:Integer);
{ IX is an index of an item in outline OL.  We want to expand
all its parents.  It appears delphi isnt very good at performing
expand so we have to do it ourselves.}

---------------------------------------------------------------------------
function Maximum(const A: array of variant):variant;
{Returns the largest item in the array
  eg aFloat := Maximum([1.111,2.222,anotherFloat,aninteger]);}

---------------------------------------------------------------------------
function MaxLineHeight(const C:Tcanvas):longint;
{ what is the maximum height of text on this canvas at present?
   Does a textheight of "y"}

---------------------------------------------------------------------------
function mbox(const hand:Thandle;const Blurb,Title:string; Flags:word):Integer;
{ ENCAPSULATION OF MESSAGEBOX FUNCTION
  THIS GIVES US A TITLE AND USES PLAIN STRINGS
  ALSO REPLACE VERTICAL BARS WITH CRLFs
  Icons:  i ... 64      ! ... 48       ? ... 32       Stop ... 16
  Buttons:  OK ... 0  Cancel+OK ... 1  Yes+No...4   Yes+No+Cancel...3
  Result:  OK...1   Cancel...2   Yes...6   No...7
}


---------------------------------------------------------------------------
Function MemoExtend(var aMemo:TMemo;MaxHeight:Integer):integer;
{ call this in a memo.OnChange event handler
  if the bottom of the memo is to be extended
  downwards/upwards to adjust to the amount of text.
  return the height in pixels of the memo
  MaxHeight limits the extent in pixels}


---------------------------------------------------------------------------
function Minimum(const A: array of variant):variant;
{Returns the smallest item in the array
  eg aFloat := Maximum([1.111,2.222,anotherFloat,aninteger]);}

---------------------------------------------------------------------------
Function NiceSmallDate(const D:TDateTime):string;
{ string representation of date in dd mmm yy format
  This is compatible with PARSEDATE()}

---------------------------------------------------------------------------
Function NotAValidDate:TDatetime;
{ return a value which we deem to be a non-date (actually 30 dec 1899) }

---------------------------------------------------------------------------
Function nthChild(const OL:Toutline;const ParentIx,ChildNo:integer):Integer;
{return the index of the nth child of the specified parent
 return -1 if ChildNo > no of children}

---------------------------------------------------------------------------
function NullField(const ADataSet:TDBDataset; Const AField:String):boolean;
{ return true if the field specified is null }

---------------------------------------------------------------------------
procedure OKBox(const Blurb:string);
{ pause with message.   Vertical bars in blurb act as CRLFs}

---------------------------------------------------------------------------
function OneOfData(const ADataSet:TDBDataset; Const AField,TheOptions:String):integer;
{ AFIELD (possibly) contains a single character.
  TheOptions is a set of characters we are testing against
  We return the position in these options *** starting at 1 ***
  eg
     case OneOfData(aTable,'TrafficLight','RAG') of   //red-amber-green
     ...
  This returns 0 if the field is empty or not one of the options.
  Case sensitive}

---------------------------------------------------------------------------
Function ParseDate(const DS: String; var dy,mo,yr:word):boolean;
{ convert the string to a date
  if ABLE TO PARSE then return true
  if YR is missing from string but >=0 when called then this is substituted 69->2069 70->1971
  if YR is missing from string but <0 then substitute current year

  Format of date string:
  1) Short string format
  -------------------------------------------
  <day><separator><month>[<separator><year>]
  where:
  <day> is one or two digits - allow leading zero
  <separator> is one of space,slash or minus
  <month> is one or two digits or a month neme or abbreviated month name
  <year> (if present) is two or 4 digits.  If 2 digits then use the hundreds
    from the YR argument when initially called

  2) Compact numeric format
  -------------------------------------------
  Always six digits ddmmyy
}


---------------------------------------------------------------------------
procedure pdecimal(const H,V:integer; DecimalString:string);
{ print a decimal number with the decimal point aligned at H
  S should contain a decimal point.  If not then it will be right justified to the point position}

---------------------------------------------------------------------------
Function PenceToSterling(const Pence:Integer):string;
{ return a nicely formatted currency string }

---------------------------------------------------------------------------
function pix(const mm:integer):integer;
{ convert mm to pixels
  NB assumes that the same printer is used throughout the program
  as the first time we use it we ask the printer to tell us -
  then it is stores for ready use

  SO IF YOU CHANGE PRINTERS USE A SPECIAL VERSION OF THIS FUNCTION
  TO FORCE A REFRESH OF THE CURRENT PRINTER PIXEL TO MM RATIO:
  CALL WITH A NEGATIVE ARGUMENT.

  eg 1st time you're printing a document after a possible printer
  (re)selection use X:=pix(0-Y) rather than X:=pix(Y)}

---------------------------------------------------------------------------
procedure pline(const H:integer; var V:integer; const S:string);
{ print out a string at the H and V pixel positions.
  increase V by the height of the text}

---------------------------------------------------------------------------
procedure pout(const H,V:integer; S:string);
{ print out a string at the H and V pixel positions.}

---------------------------------------------------------------------------
procedure poutonline(const H,V:integer; S:string);
{ textout function but with the V being the font base line not the top }

---------------------------------------------------------------------------
function ProgramNameAndDate:String;
{ return the name of the EXE file and the compilation time stamp}

---------------------------------------------------------------------------
procedure pwrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ wrap the text within the limits H1 and H2
  Increase the Vertical position V to the next free line
  Any "[..]" will result in a new line
  "[PARA]" will result in a new paragraph}

---------------------------------------------------------------------------
Function pwrappingheight(const H1,H2:integer; const ToBeWrapped:string):integer;
{ return the height that would be used if the text was wrapped
  in these limits}

---------------------------------------------------------------------------
function PX:integer;
{ printer position in pixels across page }

---------------------------------------------------------------------------
function PY:integer;
{ printer position in pixels down page }

---------------------------------------------------------------------------
Function ReadDate(Const DS:String; var DT:TDateTime):Boolean;
{ Convert string to date. See PARSEDATE}

---------------------------------------------------------------------------
Function ReadIniDetail(const IniFile,Section,Key : string):string;
{read a particular bit from the ini file}

---------------------------------------------------------------------------
function ReadIniSection(var   IniFileName : string;

---------------------------------------------------------------------------
function RectHeight(R:Trect):longint;
{ height of a Rectangle }

---------------------------------------------------------------------------
Function RectWidth(R:Trect):longint;
{ width of a rectangle }

---------------------------------------------------------------------------
function rightStr(const S:string; const L:longint) : String;
{ RETURN THE RIGHT PART OF A STRING }

---------------------------------------------------------------------------
procedure Rtrim(var S:String);
{ remove trailing spaces }

---------------------------------------------------------------------------
Function SelectNamedPrinter(Const Pname:string):boolean;
{ attempt to select a printer by name
  The name given only has to appear somewhere in the
  name of the printer
  return true if found and selected}

---------------------------------------------------------------------------
procedure setfont(const fName:string;fSize:integer);
{ quickly set the printer font
  A blank or 0 is no change for that parameter
  Fname can be a virtual font which means that if we get slightly
  different font names on a target operating system we can
  tweak the names (by hard coding) here.
  Also we can modify style throughout printing.
  negative FSIZE gives italics
  fsize + 100 gives bold
  Values: "*TIMES","*COURIER","*ARIAL",
          "*STONE",      (GM Stone Sans)
          "*STONEBOLD",  (GM Stone Sans Semi-bold)
          "*SMALL","*HEADING",}

---------------------------------------------------------------------------
function SingleData(const ADataSet:TDBDataset; Const AField:String):Single;
{Read the current record in ATable, indicated by AField
and return a single.  This is a wrapper that traps
null variants being returned and converts into 0}

---------------------------------------------------------------------------
function SLData(const ADataSet:TDBDataset; Const AField:String; var SL:TStringList):Boolean;
{ read the current record in ADataSet
  Try to fill the string list with text from a memo field (could be a string)
  return false if there is no text }

---------------------------------------------------------------------------
procedure SortOutline(var OL:Toutline;const ix:integer);
{sort the immediate children of this item in the outline.
It might be a good to hide the outline before sorting}


---------------------------------------------------------------------------
Function SQLCopyRecords(Destination:TTable; CopyMode: TBatchMode;

---------------------------------------------------------------------------
function SQLCount(var AQuery:Tquery; const S:string):integer;
{ this executes a sql query which is in the form of
  SELECT COUNT(xxx) FROM ... (or SUM,MIN,MAX or AVG etc)
  The single value is then returned}

---------------------------------------------------------------------------
Function SQLDate(Const D:TdateTime):string;
{ format the date so that it is acceptable as an input
  argument in a SQL query}

---------------------------------------------------------------------------
function StrData(const ADataSet:TDBDataset; Const AField:String):string;
{Read the current record in ATable, indicated by AField
and return a string.  This is a wrapper that traps
null variants being returned and converts into ''}

---------------------------------------------------------------------------
Function StringToArray(const S,chopper:String;  var A : Array of string):integer;
{ split the string into words as defined by the characters in chopper
  return the number of strings in the array
  return -ve if busted string array limit

  example:  nofields := StringToArray(CSVSTRING,'",',flds); }

---------------------------------------------------------------------------
function StrToFloatDef(const S:string;const F:Extended):Extended;
{ traps conversion error internally.
  Behaves as StrToIntDef()}

---------------------------------------------------------------------------
function SubStr(const S:string; const ToBeRepl:string; const ReplBy:string):string;
{ Replace one substring by another
  S : String           Host string.  REMAINS UNCHANGED
  ToBeRepl : String    To be removed
  ReplBy : String      To be substituted

  NOTE  Circular substitutions are allowed.
        If TobeRepl is null then result is S unchanged

  How to remove a whole set of characters:
    invalidchars := '/\?.:* ,';:#][=-+$^&"!%');
    for i := 1 to length(Invalidchars) do
        s := substr(s,InvalidChars[i],'');}



---------------------------------------------------------------------------
Function SubStrip(const S,ToStrip,ToSub:string):string;
{ multiple SUBSTR.  Typically used to strip a number of characters at a time.
  S       : String    Original
  ToStrip : String    Strings split by vertical bars to be replaced
  ToSub   : String    String to replace

  Example:   TidyStr := SubStrip(Str,' |.|,','');
             This would remove spaces, periods and commas completely
             }

---------------------------------------------------------------------------
procedure tActivate(aTable:TTable);
{ put the table into the active state}

---------------------------------------------------------------------------
procedure tDeActivate(aTable:TTable);
{ put the table into the inactive active state
  if necessart call post first}

---------------------------------------------------------------------------
function TFData(const ADataSet:TDBDataset; Const AField:String):boolean;
{Read the current record in ATable, indicated by AField
and return a boolean.  This is used on fields that are single
character fields used for boolean data 'T'=True any other=false
(because Paradox's "Logical" field type can't be used for
filtering)}

---------------------------------------------------------------------------
Procedure Trap;
{This will normally do nothing but can be set to do anything you like
 eg showmessage.  But really for switching on multiple breaks in one point}

---------------------------------------------------------------------------
Function TrimString(const S:String):String;
{return trimmed string}

---------------------------------------------------------------------------
function TryEdit(aTable:TTable):boolean;
{ A wrapper round the EDIT method.  This will trap locks and allow us to
  try again etc.  Return false if we can't get to editing the table }

---------------------------------------------------------------------------
Function TW(const S:string):integer;
{ shorthand for Printer.canvas.textwidth function }

---------------------------------------------------------------------------
procedure uFileCopy(const FromFile, ToFile: string);
{ COPY A FILE }

---------------------------------------------------------------------------
Function UnCapitialise(const S:String):string;
{ turn words that are completely capitialised into proper names
  eg SMITH --> Smith }

---------------------------------------------------------------------------
procedure UpdateStrData(var ATable:TTable; Const AField,NewData:string;const EraseOnly:Boolean);
{ if the new value is different then update
  Make sure we're not duplicating
  ATABLE .... Name of a table
  AFIELD .... Name of a string field
  NEWDATA ... String to make the current record, named field
  If ERASEONLY is true then if the string is already present then remove it}

---------------------------------------------------------------------------
function ValidVariant(const V:Variant):boolean;
{ return false if argument is null or empty}

---------------------------------------------------------------------------
function Vscrollwidth:Longint;
{ HOW MANY PIXELS WIDE IS THE VERTICAL SCROLL BAR?}

---------------------------------------------------------------------------
Function WhereOrAnd(const SQL,Condition:string):string;
{ We often want to add conditions to a WHERE expression
  of an SQL statement.  We can get into a bit of a twist
  with multiple conditions.  This ensures there is one
  WHERE and any subsequent are ANDs

  Returns the combination of SQL + Condition with
  the appropriate WHERE or AND in between}

---------------------------------------------------------------------------
procedure WrapIntoGridCell(Sender: TObject; C, R: Longint;
  Rect: TRect; State: TGridDrawState);
{the sort of thing where we have multi line displays for
 displaying in a grid.  Actually the wrap only works
 with hard returns ie #13+#10}

*)
